catcdc/apps/landing_page/urls.py
from django.urls import path

from .views import IndexView, ContributorsView

urlpatterns = [
    path("", IndexView.as_view(), name="landing_page"),
    path("contributors", ContributorsView.as_view(), name="contributors"),
]

catcdc/apps/vote/urls.py
from django.urls import path

from .views import ResultsView, SubmissionView, CatsView, VoteView

app_name = "vote"

urlpatterns = [
    path("vote", VoteView.as_view(), name="vote"),
    path("results", ResultsView.as_view(), name="results"),
    path("submit", SubmissionView.as_view(), name="submission"),
    path("cats", CatsView.as_view(), name="cats"),
]

catcdc/urls.py
from django.contrib import admin
from django.urls import include, path
from django.shortcuts import render

urlpatterns = [
    path("admin/", admin.site.urls),
    path("accounts/", include("social_django.urls", namespace="social")),
    path("", include("landing_page.urls")),
    path("vote/", include("vote.urls", namespace="vote")),
    path("bulk_user_add/", include("bulk_user_add.urls")),
]


# pylint:disable=unused-argument
def page_not_found(request, exception):
    return render(request, "404.html")


# pylint:disable=invalid-name
handler404 = "urls.page_not_found"

catcdc/apps/vote/models.py
from django.db import models
from django.conf import settings


class Submission(models.Model):
    # pylint:disable=line-too-long
    submitter = models.OneToOneField(
        settings.AUTH_USER_MODEL, on_delete=models.CASCADE, related_name="submitter"
    )
    cat_name = models.CharField(max_length=255)
    presentation = models.TextField(max_length=500)
    image_1 = models.ImageField()
    image_2 = models.ImageField()
    image_3 = models.ImageField()
    image_4 = models.ImageField()
    image_5 = models.ImageField()

    def __str__(self):
        return f"{self.submitter.username}: {self.cat_name}"


class Vote(models.Model):
    # pylint:disable=line-too-long
    voter = models.ForeignKey(
        settings.AUTH_USER_MODEL, on_delete=models.CASCADE, related_name="voter"
    )
    submission = models.ForeignKey(
        Submission, on_delete=models.CASCADE, related_name="submission"
    )
    weight = models.IntegerField()

    # pylint:disable=line-too-long
    def __str__(self):
        return f"{self.voter.username}: {self.weight} - {self.submission.cat_name}"

catcdc/apps/landing_page/views.py
from django.conf import settings
from django.shortcuts import render
from django.views.generic import TemplateView

from common.util import (
    is_submission_started,
    is_submission_ended,
    is_vote_started,
    is_vote_ended,
)


class IndexView(TemplateView):
    template_name = "landing_page/index.html"

    def get(self, request, *args, **kwargs):
        context = {
            "is_submission_started": is_submission_started(),
            "is_submission_ended": is_submission_ended(),
            "is_vote_started": is_vote_started(),
            "is_vote_ended": is_vote_ended(),
            "vote_start": settings.VOTE_START.isoformat(),
            "submission_start": settings.SUBMISSION_START.isoformat(),
        }
        return render(request, self.template_name, context)


class ContributorsView(TemplateView):
    template_name = "landing_page/contributors.html"

    def get(self, request, *args, **kwargs):
        context = {}
        return render(request, self.template_name, context)

catcdc/apps/landing_page/templates/landing_page/contributors.html
{% extends "base.html" %}

{% block content %}

<h3>Authors</h3>

<table>
    <tbody>
        <tr>
            <th><img src="https://acdc.risson.space/photos/solo/leane.duchet.JPG"></th>
            <th><img src="https://acdc.risson.space/photos/solo/marc.schmitt.JPG"></th>
        </tr>
        <tr>
            <th>Léane 'hylina' Duchet</th>
            <th>Marc 'risson' Schmitt</th>
        </tr>
    </tbody>
</table>

<h3>Contributors</h3>

We want to thank these people for their great contribution <3

<table>
    <tbody>
        <tr>
            <th><img src="https://photos.cri.epita.fr/thumb/adrien.navratil"></th>
            <th><img src="https://acdc.risson.space/photos/solo/bastien.germond.JPG"></th>
        </tr>
        <tr>
            <th>Adrien 'Litarvan' Navratil</th>
            <th>Bastien 'Synapze' Germond</th>
        </tr>
    </tbody>
</table>

{% endblock %}

catcdc/apps/landing_page/templates/landing_page/index.html
{% extends "base.html" %}

{% block content %}

<a href="{% url "vote:cats" %}"><button>Show me the cats!</button></a>

{% if is_submission_started and not is_submission_ended and perms.vote.add_submission and perms.vote.change_submission %}
    <br />
    <a href="{% url "vote:submission" %}"><button>Submit your cat</button></a>
{% elif is_vote_started and not is_vote_ended and perms.vote.add_vote and perms.vote.change_vote %}
    <br />
    <a href="{% url "vote:vote" %}"><button>Vote for the cutest cat</button></a>
{% endif %}

<br />
<a href="{% url "vote:results" %}"><button>Results</button></a>

{% if not is_submission_started and perms.vote.add_submission and perms.vote.change_submission %}
    <p>Submissions haven't started yet. Come back in:</p>
    {% include "countdown.html" with end=submission_start %}
{% elif not is_vote_started and perms.vote.add_vote and perms.vote.change_vote %}
    <p>Votes haven't started yet. Come back in:</p>
    {% include "countdown.html" with end=vote_start %}
{% endif %}

{% if not request.user.is_authenticated %}
    <br />
    <a href="{% url "social:begin" backend="epita" %}?next=/"><button>Epita connect</button></a>
{% endif %}

<br />
<a href="{% url "contributors" %}"><button>Contributors</button></a>

{% endblock %}